-- name: Unused Star Positions 1.01
-- description: Starasr

local Gameload = false

function loaded()
    Gameload = true
end
hook_event(HOOK_ON_MODS_LOADED, loaded)

local E_MODEL_PORPLESTAR = smlua_model_util_get_id("porplestar_geo")
local E_MODEL_PORPLESTAR3D = smlua_model_util_get_id("porplestar3d_geo")
local colon = ":"

local Savestate = false
local function savestate()
    local loadstar = mod_storage_load("star")
    star = tonumber(star) or 0
    epic_counter = star
    Savestate = true
end

hook_event(HOOK_ON_MODS_LOADED, savestate)

function bhv_porplstar_init(obj)
    obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    cur_obj_update_floor_and_walls();
    obj_scale(obj, 1.2)
    if math.random(1,4) == 2 then
        obj_set_model_extended(obj, E_MODEL_PORPLESTAR3D)
    else
        obj_set_model_extended(obj, E_MODEL_PORPLESTAR)
    end
    obj.hitboxRadius = 30
    obj.hitboxHeight = 30
    obj.oIntangibleTimer = 0
    obj.oGravity = 0
    obj.oFriction = 0
    obj.oBuoyancy = 1
    obj.hitboxDownOffset = 20
    obj.oGraphYOffset = 0
    obj.oFaceAngleYaw = 0
end

---@param obj Object
function bhv_porplstar_loop(obj)
    object_step()
    load_object_collision_model()
    local m = gMarioStates[0]
    obj.oVelY = 0
    obj.oFaceAngleYaw = obj.oFaceAngleYaw + 2250
    if obj_check_hitbox_overlap(m.marioObj,obj) then
        epic_counter = epic_counter + 1
        mod_storage_save("star", tostring(epic_counter))
        play_puzzle_jingle()
        obj_mark_for_deletion(obj)
        spawn_mist_particles()
          end
        end


id_bhvPorplStar = hook_behavior(nil, OBJ_LIST_GENACTOR, true,
    bhv_porplstar_init, bhv_porplstar_loop, "bhvPorplStar")

gLevelValues.useGlobalStarIds = true

local function mario_update(m)
if Gameload == true then
if (gNetworkPlayers[0].currAreaIndex ~= areadrea) or (gNetworkPlayers[0].currLevelNum ~= outdrea) then
    if gNetworkPlayers[0].currLevelNum == LEVEL_WF and gNetworkPlayers[0].currAreaIndex == 1 then
spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 3750, -2800,
--- @param o Object
function(o)
    o.oBehParams = 6 << 24
end)
if gNetworkPlayers[0].currActNum >= 2 then
spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 300, 5550, 0,
--- @param o Object
function(o)
    o.oBehParams = 6 << 24
end)
end
if gNetworkPlayers[0].currActNum >= 2 then
spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -400, 3700, 0,
--- @param o Object
function(o)
    o.oBehParams = 6 << 24
end)
end
spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 6666, 6350, 6666,
--- @param o Object
function(o)
    o.oBehParams = 6 << 24
end)
if gNetworkPlayers[0].currActNum >= 2 then
spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -300, 5550, 0,
--- @param o Object
function(o)
    o.oBehParams = 6 << 24
end)
end
end
if gNetworkPlayers[0].currLevelNum == LEVEL_BOB and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 0, 0,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 1550, 1200, 300,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -600, 4400, 0600,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -5500, 1500, 2300,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 5500, 3400, 1200,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_JRB and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 5100, -4500, -250,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 0, 0,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -1600, 1300, -1400,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvExclamationBox, E_MODEL_EXCLAMATION_BOX, -5000, 1400, -300,
    --- @param o Object
    function(o)
        o.oBehParams2ndByte = 1
        o.oBehParams = (1 << 16)
    end)
    spawn_non_sync_object(id_bhvExclamationBox, E_MODEL_EXCLAMATION_BOX, 120, 0, 3150,
    --- @param o Object
    function(o)
        o.oBehParams2ndByte = 1
        o.oBehParams = (1 << 16)
    end)
    spawn_non_sync_object(id_bhvExclamationBox, E_MODEL_EXCLAMATION_BOX, 4500, -4800, 4300,
    --- @param o Object
    function(o)
        o.oBehParams2ndByte = 1
        o.oBehParams = (1 << 16)
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 7190, -3200, -2150,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_JRB and gNetworkPlayers[0].currAreaIndex == 2 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -680, 1360, 1580,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 1600, 3000,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_CCM and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 3500, -4700, 4650,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 3650, -200, -1200,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -4100, -950, 1850,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_CCM and gNetworkPlayers[0].currAreaIndex == 2 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -7500, -5700, -6550,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -6550, -4500, -7500,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_BBH and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -1850, -2200, -1150,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 100, 200, 800,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 1200, 1100, 1800,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -2000, 1300, 1850,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 2500, 2000, 250,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 3150, 1150, 750,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 690, 2200, 2500,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_HMC and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 5800, -4000, 2400,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 800, 800, -3000,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -5600, 3200, 600,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -500, 2100, -7800,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_LLL and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -1450, 500, -6700,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 3850, 323, -5600,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 0, 0,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -5100, -800, -4100,
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 3850,  323, -5600,
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_LLL and gNetworkPlayers[0].currAreaIndex == 2 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 2550, 3850, -850,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_SSL and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -1500, 1300, -320,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -2000, 1500, -650,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 0, 0,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -5580, 1380, -2557,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_SSL and gNetworkPlayers[0].currAreaIndex == 2 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 1300, 4900, -400,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 1200, 1600,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_SSL and gNetworkPlayers[0].currAreaIndex == 3 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, -1000, -3800,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_DDD and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -3100, -3600, 0,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_DDD and gNetworkPlayers[0].currAreaIndex == 2 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 3900, 300, 5950,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 0, 0,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_SL and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -350, 4750, 0400,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 4800, 1000, 4300,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 4300, 1000, 500,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 5100, 0300,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 300, 1500, -5300,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -4000, 1200, 4500,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 130, 1600, -4300,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -4700, 1400, 5850,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 4377, 1843, 4361,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_WDW and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 1400, 1600, 5600,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 800, 4800, 700,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -800, 2300, -2000,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -2200, 2600, 3500,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 1550, 4350, 100,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_WDW and gNetworkPlayers[0].currAreaIndex == 2 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 600, -2650, 0,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 3000, -3100, 3200,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 5500, 500, 5500,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvWaterLevelDiamond, E_MODEL_WDW_WATER_LEVEL_DIAMOND, 4550, 3100, 4750,
    --- @param o Object
    function(o)
    end)
    spawn_non_sync_object(id_bhvWaterLevelDiamond, E_MODEL_WDW_WATER_LEVEL_DIAMOND, -400, -1950, 250,
    --- @param o Object
    function(o)
    end)
    spawn_non_sync_object(id_bhvWaterLevelDiamond, E_MODEL_WDW_WATER_LEVEL_DIAMOND, 3350, -3450, -2300,
    --- @param o Object
    function(o)
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_TTM and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 0, 0,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_TTM and gNetworkPlayers[0].currAreaIndex == 4 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -7100, -1250, -4800,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_THI and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -2550, 7400, 600,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 2500, 4200, -2500,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 350, 2700, -8500,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 3250, 6700,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -6300, -1750, -6300,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_THI and gNetworkPlayers[0].currAreaIndex == 2 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -850, 2600, 200,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 850, 1500, -850,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -150, -500, 2000,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_TTC and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -1260, -2280, -1260,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -1680, -1340, -820,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -1840, 60, -960,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -1580, 3060, -340,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, -1140, 6200, -780,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 1500, -4600, 900,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
if gNetworkPlayers[0].currLevelNum == LEVEL_RR and gNetworkPlayers[0].currAreaIndex == 1 then
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 0, 0, 0,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
    spawn_non_sync_object(id_bhvPorplStar, E_MODEL_PORPLESTAR, 5120, 4125, 4045,
    --- @param o Object
    function(o)
        o.oBehParams = 6 << 24
    end)
end
end
end
areadrea = gNetworkPlayers[0].currAreaIndex
outdrea = gNetworkPlayers[0].currLevelNum
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function hud()
    djui_hud_print_text(string.format("*" .. colon .. "%.0f", epic_counter) , 21, 204, 4)
end

hook_event(HOOK_ON_HUD_RENDER_BEHIND, hud)